#include "lcd.h"
#include "stdlib.h"
#include "usart.h"
#include "delay.h"	 
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ӲƬSTM32F103RBT6,Ƶ72M  Ƭѹ3.3V
//QDtech-TFTҺ for STM32 IOģ
//xiao@ShenZhen QDtech co.,LTD
//˾վ:www.qdtech.net
//Ավhttp://qdtech.taobao.com
//˾ṩ֧֣κμ⻶ӭʱѧϰ
//̻() :+86 0755-23594567 
//ֻ:15989313508빤 
//:QDtech2008@gmail.com 
//Skype:QDtech2008
//QQȺ:324828016
//:2013/5/13
//汾V1.1
//ȨУؾ
//Copyright(C) ȫӼ޹˾ 2009-2019
//All rights reserved
//////////////////////////////////////////////////////////////////////////////////	
/****************************************************************************************************
//=======================================Һ߽==========================================//
STM32 PBҺDB0~DB16,ΪDB0PB0,..DB15PB15.   
//=======================================Һ߽==========================================//
//LCD_CS	PC9	//Ƭѡź
//LCD_RS	PC8	//Ĵ/ѡź
//LCD_WR	PC7	//дź
//LCD_RD	PC6	//ź
//LCD_RST	PC5	//λź
//LCD_LED	PC10	//ź(ߵƽ)
//==================================================================================//
//ʹôģ鱾ɲ
//MO(MISO)	PC2	//SPI
//MI(MOSI)	PC3	//SPI
//PEN		PC1	//жź
//TCS		PC13	//ICƬѡ
//CLK		PC0	//SPIʱ
**************************************************************************************************/	
	   
//LCDҪ
//ĬΪ
_lcd_dev lcddev;

//ɫ,ɫ
u16 POINT_COLOR = 0x0000,BACK_COLOR = 0xFFFF;  
u16 DeviceCode;	 


//******************************************************************
//  LCD_WR_REG
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    Һдд16λָ
//Reg:дֵָ
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_WR_REG(u8 data)
{ 
	LCD_RS_CLR;//дַ  
 	LCD_CS_CLR; 
	 
	LCD_WR_CLR; 
	DATAOUT(data);
	LCD_WR_SET; 
 	LCD_CS_SET; 	
}

//******************************************************************
//  LCD_WR_DATA
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    Һдд16λ
//Data:д
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_WR_DATA(u16 data)
{
	LCD_RS_SET;
	LCD_CS_CLR;
	
	LCD_WR_CLR;
	DATAOUT(data);
	LCD_WR_SET;
	LCD_CS_SET;

}
//******************************************************************
//  LCD_DrawPoint_16Bit
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    8λдһ16λ
//(x,y):
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_DrawPoint_16Bit(u16 color)
{
	LCD_WR_DATA(color);

}

//******************************************************************
//  LCD_WriteReg
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    дĴ
//LCD_Reg:Ĵַ
//			LCD_RegValue:Ҫд
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue)
{	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
}	   
	 
//******************************************************************
//  LCD_WriteRAM_Prepare
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    ʼдGRAM
//			ڸҺRGBǰӦ÷дGRAMָ
//
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_WriteRAM_Prepare(void)
{
	LCD_WR_REG(lcddev.wramcmd);
}	 

//******************************************************************
//  LCD_DrawPoint
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    ָλдһص
//(x,y):
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_DrawPoint(u16 x,u16 y)
{
	LCD_SetCursor(x,y);//ùλ 
#if LCD_USE8BIT_MODEL==1
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;//дַ  	 
	DATAOUT(POINT_COLOR>>8);	
	LCD_WR_CLR;
	LCD_WR_SET;	
	DATAOUT(POINT_COLOR);	
	LCD_WR_CLR;
	LCD_WR_SET;	 
	LCD_CS_SET;
#else
	LCD_WR_DATA(POINT_COLOR); 
#endif


}

//ILI93xxΪGBRʽдʱΪRGBʽ
//ͨúת
//c:GBRʽɫֵ
//ֵRGBʽɫֵ
u16 LCD_BGR2RGB(u16 c)
{
	u16  r,g,b,rgb;   
	b=(c>>0)&0x1f;
	g=(c>>5)&0x3f;
	r=(c>>11)&0x1f;	 
	rgb=(b<<11)+(g<<5)+(r<<0);		 
	return(rgb);
}		 
//ȡĳɫֵ	 
//x,y:
//ֵ:˵ɫ
u16 LCD_ReadPoint(u16 x,u16 y)
{
 	u16 r;	
	if(x>=lcddev.width||y>=lcddev.height)return 0;	//˷Χ,ֱӷ		   
	LCD_SetCursor(x,y);
	LCD_WR_REG(0x2E);      		 		//ICͶGRAMָ
	GPIOB->CRL=0X88888888; //PB0-7  
	GPIOB->CRH=0X88888888; //PB8-15 
	GPIOB->ODR=0XFFFF;     //ȫ

	LCD_RS_SET;
	LCD_CS_CLR;

 	//dummy READ
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=DATAIN;  	//ʵɫ
	LCD_RD_SET;
	
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=DATAIN;  	//ʵɫ
	LCD_RD_SET;
	
	LCD_CS_SET;
	GPIOB->CRL=0X33333333; 		//PB0-7  
	GPIOB->CRH=0X33333333; 		//PB8-15 
	GPIOB->ODR=0XFFFF;    		//ȫ  


	return (r);
}

//ȡĳɫֵ	 
//x,y:
//ֵ:˵ɫ
u16 LCD_ID(void)
{
 	u16 r;
	
	//LCD_SetCursor(0,0);
	LCD_WR_REG(0xBF);      		 		//ICͶGRAMָ
	GPIOB->CRL=0X88888888; //PB0-7  
	GPIOB->CRH=0X88888888; //PB8-15 
	GPIOB->ODR=0XFFFF;     //ȫ

	LCD_RS_SET;
	LCD_CS_CLR;

 	//dummy READ
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=DATAIN;  	//ʵɫ
	LCD_RD_SET;
	
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=DATAIN;  	//ʵɫ
	LCD_RD_SET;
	
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=DATAIN;  	//0x62
	LCD_RD_SET;
	
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=DATAIN;  	//0x83
	LCD_RD_SET;
	
	LCD_RD_CLR;					   
	delay_us(1);//ʱ1us					   
 	r=(r<<8)|DATAIN;  	//0x83
	LCD_RD_SET;
	
	LCD_CS_SET;
	GPIOB->CRL=0X33333333; 		//PB0-7  
	GPIOB->CRH=0X33333333; 		//PB8-15 
	GPIOB->ODR=0XFFFF;    		//ȫ  


	return (r);
}
//******************************************************************
//  LCD_Clear
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    LCDȫ
//Color:Ҫɫ
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_Clear(u16 Color)
{
	u32 index=0; 
u32 total=0; 	
total=lcddev.width*lcddev.height;  
	LCD_SetWindows(0,0,lcddev.width-1,lcddev.height-1);	
	LCD_RS_SET;
	LCD_CS_CLR;
	
	
	for(index=0;index<total;index++)
	{
		//LCD_WR_DATA(Color);		
DATAOUT(Color);
	LCD_WR_CLR;
	LCD_WR_SET;		
	}
//LCD_CS_SET;
	
} 

//******************************************************************
//  LCD_GPIOInit
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    ҺIOʼҺʼǰҪô˺
//
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_GPIOInit(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOB|RCC_APB2Periph_AFIO, ENABLE); 
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable , ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10|GPIO_Pin_9|GPIO_Pin_8|GPIO_Pin_7|GPIO_Pin_6|GPIO_Pin_5;	   //GPIO_Pin_10
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure); //GPIOC	
	GPIO_SetBits(GPIOC,GPIO_Pin_10|GPIO_Pin_9|GPIO_Pin_8|GPIO_Pin_7|GPIO_Pin_6|GPIO_Pin_5);


	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;	//  
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure); //GPIOB
	GPIO_SetBits(GPIOB,GPIO_Pin_All);	 
}

//******************************************************************
//  LCD_Reset
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    LCDλҺʼǰҪô˺
//
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_RESET(void)
{
	LCD_RST_CLR;
	delay_ms(100);	
	LCD_RST_SET;
	delay_ms(50);
}
 	 
//******************************************************************
//  LCD_Init
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    LCDʼ
//
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_Init(void)
{  
     										 
	LCD_GPIOInit();
 	LCD_RESET();
	LCD_RD_SET;//RDûõĻӦߣPCBģֱ߽VCC
//=========================Һʼ=============================//
	LCD_WR_REG(0XB9);//Set EXTC
	LCD_WR_DATA(0xFF);
	LCD_WR_DATA(0x83);
	LCD_WR_DATA(0x57);
	delay_ms(50);
	
	LCD_WR_REG(0XB6);//Set VCOMDC
	LCD_WR_DATA(0x2C);//0x52 for HSD 3.0"
	
	LCD_WR_REG(0X11);//
	delay_ms(200);
	
	LCD_WR_REG(0X35);//TE ON
	LCD_WR_REG(0X003A);
	LCD_WR_DATA(0X0055);//65K

	/*
	LCD_WR_REG(0XCC);//Set Panel
	LCD_WR_DATA(0X09);//
	*/
	/*
	LCD_WR_REG(0XB3);//COLOR FORMAT
	LCD_WR_DATA(0X43);//
	LCD_WR_DATA(0X00);//
	LCD_WR_DATA(0X06);//
	LCD_WR_DATA(0X06);//
	*/
	LCD_WR_REG(0XB1);//
	LCD_WR_DATA(0X00);//
	LCD_WR_DATA(0X15);//
	LCD_WR_DATA(0X0D);//0D
	LCD_WR_DATA(0X0D);//0D
	LCD_WR_DATA(0X83);//
	LCD_WR_DATA(0X48);//
	
	
	LCD_WR_REG(0XC0);//
	LCD_WR_DATA(0X24);//
	LCD_WR_DATA(0X24);//
	LCD_WR_DATA(0X01);//
	LCD_WR_DATA(0X3C);//
	LCD_WR_DATA(0XC8);//
	LCD_WR_DATA(0X08);//
	
	LCD_WR_REG(0XB4);//
	LCD_WR_DATA(0X02);//
	LCD_WR_DATA(0X40);//
	LCD_WR_DATA(0X00);//
	LCD_WR_DATA(0X2A);//
	LCD_WR_DATA(0X2A);//
	LCD_WR_DATA(0X0D);//
	LCD_WR_DATA(0X4F);//
	
	LCD_WR_REG(0XE0);//
	LCD_WR_DATA(0X00);//
	LCD_WR_DATA(0X15);//
	LCD_WR_DATA(0X1D);//
	LCD_WR_DATA(0X2A);//
	LCD_WR_DATA(0X31);//
	LCD_WR_DATA(0X42);//
	LCD_WR_DATA(0X4C);//
	LCD_WR_DATA(0X53);//
	LCD_WR_DATA(0X45);//
	LCD_WR_DATA(0X40);//
	LCD_WR_DATA(0X3B);//
	LCD_WR_DATA(0X32);//
	LCD_WR_DATA(0X2E);//
	LCD_WR_DATA(0X28);//
	
	LCD_WR_DATA(0X24);//
	LCD_WR_DATA(0X03);//
	LCD_WR_DATA(0x00);//
	LCD_WR_DATA(0X15);//
	LCD_WR_DATA(0X1D);//
	LCD_WR_DATA(0X2A);//
	LCD_WR_DATA(0X31);//
	LCD_WR_DATA(0X42);//
	LCD_WR_DATA(0X4C);//
	LCD_WR_DATA(0X53);//
	LCD_WR_DATA(0X45);//
	LCD_WR_DATA(0X40);//
	LCD_WR_DATA(0X3B);//
	LCD_WR_DATA(0X32);//
	
	LCD_WR_DATA(0X2E);//
	LCD_WR_DATA(0X28);//
	LCD_WR_DATA(0X24);//
	LCD_WR_DATA(0X03);//
	LCD_WR_DATA(0X00);//
	LCD_WR_DATA(0X01);//

	LCD_WR_REG(0x36);
	LCD_WR_DATA(0x48);
	delay_ms(20);
	LCD_WR_REG(0x21);//Display inversion ON
	delay_ms(20);
	LCD_WR_REG(0x29);
	
	delay_ms(120);
	

	LCD_SetParam();//LCD	 
	LCD_LED=1;//	 
	LCD_Clear(WHITE);
}
  		  
//******************************************************************
//  LCD_SetWindows
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    ʾ
//(xStar,yStar):Ͻʼ
//	 	   	(xEnd,yEnd):½ǽ
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
{	
	LCD_WR_REG(lcddev.setxcmd);	
	LCD_WR_DATA(xStar>>8);
	LCD_WR_DATA(xStar);		
	LCD_WR_DATA(xEnd>>8);
	LCD_WR_DATA(xEnd);

	LCD_WR_REG(lcddev.setycmd);	
	LCD_WR_DATA(yStar>>8);
	LCD_WR_DATA(yStar);		
	LCD_WR_DATA(yEnd>>8);
	LCD_WR_DATA(yEnd);

	LCD_WriteRAM_Prepare();	//ʼдGRAM		
//delay_us(1);	
}   

//******************************************************************
//  LCD_SetCursor
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    ùλ
//Xpos:
//			Ypos:
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{	  	    			
	LCD_SetWindows(Xpos,Ypos,Xpos+1,Ypos+1);		
} 

//******************************************************************
//  LCD_SetParam
//ߣ    xiao@ȫ
//ڣ    2013-02-22
//ܣ    LCDкģʽл
//
//ֵ  
//޸ļ¼
//******************************************************************
void LCD_SetParam(void)
{ 
	lcddev.setxcmd=0x2A;
	lcddev.setycmd=0x2B;
	lcddev.wramcmd=0x2C;
#if USE_HORIZONTAL==1	//ʹú	  
	lcddev.dir=1;//
	lcddev.width=480;
	lcddev.height=320;			
	LCD_WriteReg(0x36,0x3B);//BGR==1,MY==1,MX==0,MV==1  63
#else//
	lcddev.dir=0;//				 	 		
	lcddev.width=320;
	lcddev.height=480;	
	LCD_WriteReg(0x36,(1<<3)|(1<<6));//BGR==1,MY==0,MX==0,MV==0
#endif
}	

